Index: issm/trunk/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Penta.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Penta.cpp	(revision 18301)
@@ -2940,336 +2830,4 @@
 
 }/*}}}*/
-void       Penta::GradientIndexing(int* indexing,int control_index){/*{{{*/
-
-	/*Get some parameters*/
-	int num_controls;
-	parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
-
-	/*get gradient indices*/
-	for(int i=0;i<NUMVERTICES;i++){
-		indexing[i]=num_controls*this->vertices[i]->Pid() + control_index;
-	}
-
-}
-/*}}}*/
-void       Penta::Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index){/*{{{*/
-	/*dJ/dalpha = ∂L/∂alpha = ∂J/∂alpha + ∂/∂alpha(KU-F)*/
-
-	int   approximation;
-	Tria* tria=NULL;
-
-	/*If on water, skip grad (=0): */
-	if(!IsIceInElement())return;
-					
-	/*First deal with ∂/∂alpha(KU-F)*/
-	switch(control_type){
-
-		case FrictionCoefficientEnum:
-			inputs->GetInputValue(&approximation,ApproximationEnum);
-			switch(approximation){
-				case SSAApproximationEnum:
-					GradjDragSSA(gradient,control_index);
-					break;
-				case HOApproximationEnum:
-					GradjDragHO(gradient,control_index);
-					break;
-				case FSApproximationEnum:
-					GradjDragFS(gradient,control_index);
-					break;
-				case NoneApproximationEnum:
-					/*Gradient is 0*/
-					break;
-				default:
-					_error_("approximation " << EnumToStringx(approximation) << " not supported yet");
-			}
-			break;
-
-		case MaterialsRheologyBbarEnum:
-			inputs->GetInputValue(&approximation,ApproximationEnum);
-			switch(approximation){
-				case SSAApproximationEnum:
-					GradjBbarSSA(gradient,control_index);
-					break;
-				case HOApproximationEnum:
-					GradjBbarHO(gradient,control_index);
-					break;
-				case FSApproximationEnum:
-					GradjBbarFS(gradient,control_index);
-					break;
-				case NoneApproximationEnum:
-					/*Gradient is 0*/
-					break;
-				default:
-					_error_("approximation " << EnumToStringx(approximation) << " not supported yet");
-			}
-			break;
-
-		default:
-			_error_("control type " << EnumToStringx(control_type) << " not supported yet: ");
-	}
-
-	/*Now deal with ∂J/∂alpha*/
-	int *responses = NULL;
-	int num_responses,resp;
-	this->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
-	this->parameters->FindParam(&responses,NULL,InversionCostFunctionsEnum);
-
-	for(resp=0;resp<num_responses;resp++) switch(responses[resp]){
-
-		case ThicknessAbsMisfitEnum:
-		case SurfaceAbsVelMisfitEnum:
-		case SurfaceRelVelMisfitEnum:
-		case SurfaceLogVelMisfitEnum:
-		case SurfaceLogVxVyMisfitEnum:
-		case SurfaceAverageVelMisfitEnum:
-			/*Nothing, J does not depends on the parameter being inverted for*/
-			break;
-		case DragCoefficientAbsGradientEnum:
-			if(IsOnBase()){
-				tria=(Tria*)SpawnTria(0,1,2);
-				tria->GradjDragGradient(gradient,control_index);
-				delete tria->material; delete tria;
-			}
-			break;
-		case RheologyBbarAbsGradientEnum:
-			if(IsOnBase()){
-				tria=(Tria*)SpawnTria(0,1,2);
-				tria->GradjBGradient(gradient,control_index);
-				delete tria->material; delete tria;
-			}
-			break;
-		default:
-			_error_("response " << EnumToStringx(responses[resp]) << " not supported yet");
-	}
-	xDelete<int>(responses);
-}
-/*}}}*/
-void       Penta::GradjDragSSA(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Gradient is 0 if on shelf or not on bed*/
-	if(IsFloating() || !IsOnBase()) return;
-
-	/*Spawn tria*/
-	Tria* tria=(Tria*)SpawnTria(0,1,2);
-	tria->GradjDragSSA(gradient,control_index);
-	delete tria->material; delete tria;
-
-} /*}}}*/
-void       Penta::GradjDragHO(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i,j;
-	int        analysis_type;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble vx,vy,lambda,mu,alpha_complement,Jdet;
-	IssmDouble bed,thickness,Neff,drag;
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble xyz_list_tria[NUMVERTICES2D][3]={0.0};
-	IssmDouble dk[NDOF3]; 
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	IssmDouble grade_g_gaussian[NUMVERTICES];
-	IssmDouble basis[6];
-	Friction*  friction=NULL;
-	GaussPenta *gauss=NULL;
-
-	/*Gradient is 0 if on shelf or not on bed*/
-	if(IsFloating() || !IsOnBase()) return;
-
-	/*Retrieve all inputs and parameters*/
-	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	GradientIndexing(&vertexpidlist[0],control_index);
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	for(i=0;i<NUMVERTICES2D;i++) for(j=0;j<3;j++) xyz_list_tria[i][j]=xyz_list[i][j];
-	Input* adjointx_input=inputs->GetInput(AdjointxEnum);               _assert_(adjointx_input);
-	Input* adjointy_input=inputs->GetInput(AdjointyEnum);               _assert_(adjointy_input);
-	Input* vx_input=inputs->GetInput(VxEnum);                           _assert_(vx_input);
-	Input* vy_input=inputs->GetInput(VyEnum);                           _assert_(vy_input);
-	Input* dragcoefficient_input=inputs->GetInput(FrictionCoefficientEnum); _assert_(dragcoefficient_input);
-
-	/*Build frictoin element, needed later: */
-	friction=new Friction(this,2);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussPenta(0,1,2,4);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetTriaJacobianDeterminant(&Jdet, &xyz_list_tria[0][0],gauss);
-		GetNodalFunctionsP1(basis,gauss);
-
-		/*Build alpha_complement_list: */
-		friction->GetAlphaComplement(&alpha_complement,gauss);
-
-		dragcoefficient_input->GetInputValue(&drag, gauss);
-		adjointx_input->GetInputValue(&lambda, gauss);
-		adjointy_input->GetInputValue(&mu, gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
-		dragcoefficient_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++){
-			grade_g_gaussian[i]=-2*drag*alpha_complement*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
-		}
-
-		/*Add gradje_g_gaussian vector to gradje_g: */
-		for(i=0;i<NUMVERTICES;i++){
-			_assert_(!xIsNan<IssmDouble>(grade_g[i]));
-			grade_g[i]+=grade_g_gaussian[i];
-		}
-	}
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-	delete friction;
-}
-/*}}}*/
-void       Penta::GradjDragFS(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i,j;
-	int        analysis_type;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble bed,thickness,Neff;
-	IssmDouble lambda,mu,xi,Jdet,vx,vy,vz;
-	IssmDouble alpha_complement,drag;
-	IssmDouble surface_normal[3],bed_normal[3];
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble xyz_list_tria[NUMVERTICES2D][3]={0.0};
-	IssmDouble dk[NDOF3]; 
-	IssmDouble basis[6];
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	IssmDouble grade_g_gaussian[NUMVERTICES];
-	Friction*  friction=NULL;
-	GaussPenta* gauss=NULL;
-
-	/*Gradient is 0 if on shelf or not on bed*/
-	if(IsFloating() || !IsOnBase()) return;
-
-	/*Retrieve all inputs and parameters*/
-	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	for(i=0;i<NUMVERTICES2D;i++) for(j=0;j<3;j++) xyz_list_tria[i][j]=xyz_list[i][j];
-	GradientIndexing(&vertexpidlist[0],control_index);
-	Input* drag_input    =inputs->GetInput(FrictionCoefficientEnum); _assert_(drag_input);
-	Input* vx_input      =inputs->GetInput(VxEnum);                  _assert_(vx_input);
-	Input* vy_input      =inputs->GetInput(VyEnum);                  _assert_(vy_input);
-	Input* vz_input      =inputs->GetInput(VzEnum);                  _assert_(vz_input);
-	Input* adjointx_input=inputs->GetInput(AdjointxEnum);            _assert_(adjointx_input);
-	Input* adjointy_input=inputs->GetInput(AdjointyEnum);            _assert_(adjointy_input);
-	Input* adjointz_input=inputs->GetInput(AdjointzEnum);            _assert_(adjointz_input);
-
-	/*Build frictoin element, needed later: */
-	friction=new Friction(this,3);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussPenta(0,1,2,4);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		/*Recover alpha_complement and drag: */
-		friction->GetAlphaComplement(&alpha_complement,gauss);
-		drag_input->GetInputValue(&drag,gauss);
-
-		/*recover lambda mu and xi: */
-		adjointx_input->GetInputValue(&lambda,gauss);
-		adjointy_input->GetInputValue(&mu    ,gauss);
-		adjointz_input->GetInputValue(&xi    ,gauss);
-
-		/*recover vx vy and vz: */
-		vx_input->GetInputValue(&vx, gauss);
-		vy_input->GetInputValue(&vy, gauss);
-		vz_input->GetInputValue(&vz, gauss);
-
-		/*Get normal vector to the bed */
-		NormalTop(&surface_normal[0],&xyz_list_tria[0][0]);
-
-		bed_normal[0]=-surface_normal[0]; //Function is for upper surface, so the normal to the bed is the opposite of the result
-		bed_normal[1]=-surface_normal[1];
-		bed_normal[2]=-surface_normal[2];
-
-		/* Get Jacobian determinant: */
-		GetTriaJacobianDeterminant(&Jdet,&xyz_list_tria[0][0],gauss);
-		GetNodalFunctionsP1(basis, gauss);
-
-		/*Get k derivative: dk/dx */
-		drag_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++){
-			//standard gradient dJ/dki
-			grade_g_gaussian[i]=(
-						-lambda*(2*drag*alpha_complement*(vx - vz*bed_normal[0]*bed_normal[2]))
-						-mu    *(2*drag*alpha_complement*(vy - vz*bed_normal[1]*bed_normal[2]))
-						-xi    *(2*drag*alpha_complement*(-vx*bed_normal[0]*bed_normal[2]-vy*bed_normal[1]*bed_normal[2]))
-						)*Jdet*gauss->weight*basis[i]; 
-		}
-
-		/*Add gradje_g_gaussian vector to gradje_g: */
-		for( i=0; i<NUMVERTICES; i++)grade_g[i]+=grade_g_gaussian[i];
-	}
-
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	delete friction;
-	delete gauss;
-}
-/*}}}*/
-void       Penta::GradjBbarSSA(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*This element should be collapsed into a tria element at its base*/
-	if (!IsOnBase()) return; 
-
-	/*Depth Average B*/
-	this->InputDepthAverageAtBase(MaterialsRheologyBEnum,MaterialsRheologyBbarEnum);
-	if(this->material->IsDamage())this->InputDepthAverageAtBase(DamageDEnum,DamageDbarEnum);
-
-	/*Collapse element to the base*/
-	Tria* tria=(Tria*)SpawnTria(0,1,2);
-	tria->GradjBSSA(gradient,control_index);
-	delete tria->material; delete tria;
-
-	/*delete Average B*/
-	this->inputs->DeleteInput(MaterialsRheologyBbarEnum);
-	this->inputs->DeleteInput(DamageDbarEnum);
-
-} /*}}}*/
-void       Penta::GradjBbarHO(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Gradient is computed on bed only (Bbar)*/
-	if (!IsOnBase()) return;
-
-	/*Depth Average B and D*/
-	this->InputDepthAverageAtBase(MaterialsRheologyBEnum,MaterialsRheologyBbarEnum);
-	if(this->material->IsDamage())this->InputDepthAverageAtBase(DamageDEnum,DamageDbarEnum);
-
-	/*Collapse element to the base*/
-	Tria* tria=(Tria*)SpawnTria(0,1,2);
-	tria->GradjBSSA(gradient,control_index);    //We use SSA as an estimate for now
-	delete tria->material; delete tria;
-
-	/*delete Average B*/
-	this->inputs->DeleteInput(MaterialsRheologyBbarEnum);
-	this->inputs->DeleteInput(DamageDbarEnum);
-} /*}}}*/
-void       Penta::GradjBbarFS(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	/*Gradient is computed on bed only (Bbar)*/
-	if (!IsOnBase()) return;
-
-	/*Depth Average B and D*/
-	this->InputDepthAverageAtBase(MaterialsRheologyBEnum,MaterialsRheologyBbarEnum);
-	if(this->material->IsDamage())this->InputDepthAverageAtBase(DamageDEnum,DamageDbarEnum);
-
-	/*Collapse element to the base*/
-	Tria* tria=(Tria*)SpawnTria(0,1,2);
-	tria->GradjBSSA(gradient,control_index);    //We use SSA as an estimate for now
-	delete tria->material; delete tria;
-
-	/*delete Average B*/
-	this->inputs->DeleteInput(MaterialsRheologyBbarEnum);
-	this->inputs->DeleteInput(DamageDbarEnum);
-} /*}}}*/
 void       Penta::InputControlUpdate(IssmDouble scalar,bool save_parameter){/*{{{*/
 
@@ -3326,4 +2884,5 @@
 
 	/*Get input (either in element or material)*/
+	if(control_enum==MaterialsRheologyBbarEnum) control_enum=MaterialsRheologyBEnum;
 	Input* input=inputs->GetInput(control_enum);
 	if(!input) _error_("Input " << EnumToStringx(control_enum) << " not found in element");
@@ -3340,7 +2899,16 @@
 
 	IssmDouble  values[NUMVERTICES];
-	int     vertexpidlist[NUMVERTICES];
-	Input  *input     = NULL;
-	Input  *new_input = NULL;
+	int         vertexpidlist[NUMVERTICES],control_init;
+
+	/*Specific case for depth averaged quantities*/
+	control_init=control_enum;
+	if(control_enum==MaterialsRheologyBbarEnum){
+		control_enum=MaterialsRheologyBEnum;
+		if(!IsOnBase()) return;
+	}
+	if(control_enum==DamageDbarEnum){
+		control_enum=DamageDEnum;
+		if(!IsOnBase()) return;
+	}
 
 	/*Get out if this is not an element input*/
@@ -3351,15 +2919,21 @@
 
 	/*Get values on vertices*/
-	for (int i=0;i<NUMVERTICES;i++){
+	for(int i=0;i<NUMVERTICES;i++){
 		values[i]=vector[vertexpidlist[i]];
 	}
-	new_input = new PentaInput(control_enum,values,P1Enum);
-	input=(Input*)this->inputs->GetInput(control_enum);   _assert_(input);
-
-	if (input->ObjectEnum()!=ControlInputEnum){
+	Input* new_input = new PentaInput(control_enum,values,P1Enum);
+	Input* input=(Input*)this->inputs->GetInput(control_enum);   _assert_(input);
+	if(input->ObjectEnum()!=ControlInputEnum){
 		_error_("input " << EnumToStringx(control_enum) << " is not a ControlInput");
 	}
 
 	((ControlInput*)input)->SetInput(new_input);
+
+	if(control_init==MaterialsRheologyBbarEnum){
+		this->InputExtrude(control_enum);
+	}
+	if(control_init==DamageDbarEnum){
+		this->InputExtrude(control_enum);
+	}
 }
 /*}}}*/
@@ -3538,8 +3112,5 @@
 
 	int        i,migration_style;
-	bool       oldfloating;
-	bool       floatingelement = false;
-	bool       groundedelement = false;
-	IssmDouble bed_hydro,yts,gl_melting_rate;
+	IssmDouble bed_hydro,yts;
 	IssmDouble rho_water,rho_ice,density;
 	IssmDouble h[NUMVERTICES],s[NUMVERTICES],b[NUMVERTICES],r[NUMVERTICES];
@@ -3550,5 +3121,4 @@
 	/*Recover info at the vertices: */
 	parameters->FindParam(&migration_style,GroundinglineMigrationEnum);
-	parameters->FindParam(&gl_melting_rate,GroundinglineMeltingRateEnum);
 	parameters->FindParam(&yts,ConstantsYtsEnum);
 	GetInputListOnVertices(&h[0],ThicknessEnum);
@@ -3560,5 +3130,4 @@
 	rho_ice     = matpar->GetRhoIce();
 	density     = rho_ice/rho_water;
-	oldfloating = this->IsFloating(); //figure out if the element is floating before starting to change everything
 
 	/*go through vertices, and update inputs, considering them to be PentaVertex type: */
@@ -3605,29 +3174,4 @@
 	this->InputExtrude(MaskGroundediceLevelsetEnum);
 
-	/*SubelementMigrationEnum: if one grounded, all grounded*/
-	if(migration_style==SubelementMigrationEnum || migration_style==SubelementMigration2Enum){
-		for(i=0;i<NUMVERTICES;i++){
-			if(phi[i]>0.){
-				groundedelement=true;
-				break;
-			}
-		}
-		floatingelement=!groundedelement;
-	}
-	else{
-		for(i=0;i<NUMVERTICES;i++){
-			if(phi[i]<=0.){
-				floatingelement=true;
-				break;
-			}
-		}
-	}
-
-   /*Add basal melting rate if element just ungrounded*/
-	if(!oldfloating && floatingelement==true){
-		for(i=0;i<NUMVERTICES;i++)melting[i]=gl_melting_rate/yts;
-		this->inputs->AddInput(new PentaInput(BasalforcingsMeltingRateEnum,&melting[0],P1Enum));
-	} 
-
 	/*Update inputs*/
 	this->inputs->AddInput(new PentaInput(SurfaceEnum,&s[0],P1Enum));
Index: issm/trunk/src/c/classes/Elements/Penta.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Penta.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Penta.h	(revision 18301)
@@ -54,6 +54,4 @@
 		IssmDouble CharacteristicLength(void){_error_("not implemented yet");};
 		void   ComputeBasalStress(Vector<IssmDouble>* sigma_b);
-		void   ComputeStrainRate();
-		void   ComputeStrainRate(Vector<IssmDouble>* eps){_error_("not implemented yet");};
 		void   ComputeSigmaNN(){_error_("not implemented yet");};
 		void   ComputeStressTensor();
@@ -64,4 +62,5 @@
 		void   FSContactMigration(Vector<IssmDouble>* vertexgrounded,Vector<IssmDouble>* vertexfloating);
 		void   SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Materials* materials,Parameters* parameters);
+		void   ResetHooks();
 		void   Delta18oParameterization(void);
 		Penta* GetUpperPenta(void);
@@ -75,4 +74,5 @@
 		int    GetNodeIndex(Node* node);
 		int    GetNumberOfNodes(void);
+		int    GetNumberOfNodes(int enum_type);
 		int    GetNumberOfVertices(void);
 		void   GetSolutionFromInputsOneDof(Vector<IssmDouble>* solution,int enum_type);
@@ -92,8 +92,8 @@
 		void   ZeroLevelsetCoordinates(IssmDouble** pxyz_zero,IssmDouble* xyz_list,int levelsetenum);
 		void   GetIcefrontCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum){_error_("not implemented yet");};
+		void   GetLevelCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum,IssmDouble level){_error_("not implemented yet");};
 		void   PositiveDegreeDay(IssmDouble* pdds,IssmDouble* pds,IssmDouble signorm);
 		void   ReduceMatrices(ElementMatrix* Ke,ElementVector* pe);
 		void   ResetFSBasalBoundaryCondition(void);
-		void   SmbGradients();
 		void   SetTemporaryElementType(int element_type_in);
 	   Element* SpawnBasalElement(void);
@@ -113,18 +113,7 @@
 		IssmDouble IceVolumeAboveFloatation(void);
 		IssmDouble TotalSmb(void);
-		void   MinVel(IssmDouble* pminvel);
-		void   MinVx(IssmDouble* pminvx);
-		void   MinVy(IssmDouble* pminvy);
-		void   MinVz(IssmDouble* pminvz);
 		IssmDouble MassFlux(IssmDouble* segment);
 		IssmDouble MassFlux(IssmDouble x1,IssmDouble y1, IssmDouble x2, IssmDouble y2,int segment_id);
-		void   MaxAbsVx(IssmDouble* pmaxabsvx);
-		void   MaxAbsVy(IssmDouble* pmaxabsvy);
-		void   MaxAbsVz(IssmDouble* pmaxabsvz);
-		void   MaxVel(IssmDouble* pmaxvel);
 		void   ElementResponse(IssmDouble* presponse,int response_enum);
-		void   MaxVx(IssmDouble* pmaxvx);
-		void   MaxVy(IssmDouble* pmaxvy);
-		void   MaxVz(IssmDouble* pmaxvz);
 
 		#ifdef _HAVE_GIA_
@@ -132,16 +121,6 @@
 		#endif
 
-		void   GradientIndexing(int* indexing,int control_index);
-		void   Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index);
-		void   GradjDragSSA(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjDragHO(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjDragFS(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjBbarSSA(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjBbarHO(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjBbarFS(Vector<IssmDouble>* gradient,int control_index);
 		void   GetVectorFromControlInputs(Vector<IssmDouble>* gradient,int control_enum,int control_index,const char* data);
 		void   SetControlInputsFromVector(IssmDouble* vector,int control_enum,int control_index);
-		void   ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index);
-		void   ControlInputScaleGradient(int enum_type,IssmDouble scale);
 		void   ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index);
 		void   ControlToVectors(Vector<IssmPDouble>* vector_control, Vector<IssmPDouble>* vector_gradient,int control_enum);
@@ -186,4 +165,5 @@
 		void           NodalFunctions(IssmDouble* basis,Gauss* gauss);
 		void           NodalFunctionsP1(IssmDouble* basis,Gauss* gauss);
+		void           NodalFunctionsP2(IssmDouble* basis,Gauss* gauss);
 		void           NodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss);
 		void           NodalFunctionsP1Derivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss);
